package com.bocloud.cms.entity;

import com.bocloud.common.utils.DateDeserializer;
import com.bocloud.common.utils.DateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 监控资源实体类
 *
 * @author zhangyf
 * @Version 1.0
 * @since 2019-07-15
 */
@Data
@EqualsAndHashCode
public class Resource {

    private Long id; // ID
    private String name;//名称
    private String type;// 资源类型
    private String data;// 数据库连接信息
    private boolean monitoring = false; //是否开启监控
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;
    private Long creatorId;
    private Boolean deleted = false;
    private Long tenantId;
    private Long projectId;

}