package com.bocloud.ims.entity;

import com.bocloud.common.utils.DateDeserializer;
import com.bocloud.common.utils.DateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 云供应商实体类
 *
 * @author wangyu
 */
@Data
@EqualsAndHashCode
public class CloudVendor {

    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtCreate;
    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtModify;
    private Long creatorId;
    private Long ownerId;
    private Long menderId;
    private String name;
    private String status;
    private Boolean deleted;
    private String props;
    private String remark;


    private Long id; // ID
    private String type; // 平台类型
    private Long envId;// 所在环境
    private String uuid; // butler uuid
    private String guid;// 全局唯一标识
    private Boolean isAlarm;// 是否开启告警
    private Boolean isPublic;// 是否为公有云
    private String syncCron;// 云平台同步任务cron
    private Long dcId;// 数据中心id
    private String version;// 版本
    private String logo;// 平台图标
    private String vendorCategory;// 平台分类
    private String authentication;// 平台认证信息(address,account,password,tenant,access_key,secret_key,domain_name,project_name,region_id,regions,management_ips,subscription_id,client_id,token)
    private String region;// 区域
    private String availablitiyZone;// 可用域
    private String location; // 站点位置
    private String supplier; // 供应商
    private String dockerAddress; // 供应商

    private String remoteSite; // 远程站点

    private String deployUrl; // 部署机url
    private String deployUsername; // 部署机用户名
    private String deployPassword; // 部署机密码
    private Long harborId;

    private String harborName;

    private String regionsName;

    private String envName;

    private String dcName;

    private Long instance; // 实例数量

    private Long online; // 在线

    private Long offline; // 离线

    private Long hostCount;// 主机数量

    private Long dataStoreCount;// 数据存储数量

    private Long templateCount;// 模板数量

    private Long clusterCount;// 集群数量

    private Long imageCount;// 镜像数量

    private Long cpuCount;// cpu核数

    private Long monCount;// 控制节点数量

    private Long osdCount; // osd节点数量

    private Long mdsCount;// mds节点数量

    private Long cpuTotal; // cpu总赫兹

    private Long cpuUsed;

    private Long cpuUnused;

    private BigDecimal memTotal;// 总内存

    private BigDecimal memUsed;

    private BigDecimal memUnused;

    private BigDecimal diskTotal;

    private BigDecimal diskUsed;

    private BigDecimal diskUnused;

    private Long tenantCount;// 租户数量

    private Long networkCount;// 网络数量

    private Long vsCount;// virtual server数量

    private Long poolCount;// pool数量

    private Long nodeCount;// node数量

    private Long profileCount;// profile数量

    private Long monitorCount;// monitor数量

    private Long vpcCount; // vpc数量

    private Long lparCount;// 逻辑分区数量

    private Long viosCount; // 虚拟IO服务器数量

    private Long mdiskCount; // mdisk数量

    private Long flashCopyCount;// FlashCopy数量

    private Long fabricCount;// 光纤交换机数量

    private Long zoneCount; // zone的数量

    private Long nsCount; // k8s namespace count

    private Long podCount;

    private Long serviceCount;

    private Long deploymentCount;

    private Long aliasCount; // 别名的数量

    private Long accessPathCount;

    private Long edgeClusterCount;// edge集群

    private Long groupCount;// NS组

    private Long transportZoneCount;// 传输区域

    private Long firewallCount;// 防火墙

    private Long routerCount;// 路由器

    private Long switchCount;// 交换机

    private Long objectUserCount;// 对象用户

    private Long objectBucketCount;// 存储桶

    private Long objectRouterCount;// 对象路由


    private Long fileUserCount; // xsky 文件用户

    private Long fileClientCount; // xsky 文件客户端

    private Long snapshotCount; // 快照

    private Long fileSystemCount; // 文件系统数量

    private Long logicPortCount; // 逻辑端口

    private Long vasCount; // 逻辑vas

    private Long dbCount; // 堡垒机-数据库数量

    private Long appCount; // 堡垒机-应用数量

    private Long sessionCount; // 堡垒机-会话数量
    /********** vmware horizon桌面池统计 **************/

    private Long desktopPools;

    private Long farms;

    private Long sessions;

    private Long users;

    private Long vcenters;

    private Long vendorGroupId;

}
