package com.bocloud.ims.entity;

import com.bocloud.common.utils.DateDeserializer;
import com.bocloud.common.utils.DateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * HMC分区类
 *
 * @author ShaolongTan
 */
@EqualsAndHashCode(callSuper = false)
@Data
public class HmcPartition {

    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtCreate;
    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtModify;
    private Long creatorId;
    private Long ownerId;
    private Long menderId;
    private String name;
    private String status;
    private Boolean deleted;
    private String props;
    private String remark;

    private Long id; // ID
    private Long serverId;
    private Integer hmcPartitionId;
    private String partitionType;
    private String uuid;
    private Double processor;
    private Double memory;
    private String code;
    private String ip;
    private String osVersion;
    private Boolean ledOn;
    private String processorCompatibilityMode;
    private String keyLockPosition;
    private Boolean errorPathReport;
    private Boolean servicePartition;
    private String currentProfileSync;
    private Boolean connMonitorEnabled; // 连接监视
    private Boolean allowPerformanceCollection; // 允许性能数据收集
    private String rmcState;// rmc连接状态
    private Long tenantId;
    private Integer currentMaxVirtualIOSlots;
    private String pendingProcessorCompatibilityMode;

    private String serverUuid;
    private String schemaVersion;
    private String profileName;
    private String serverName;
    private Double value;

    //用于cms监控
    private String thresholdGroupName;//阈值组
    private String policyName;//分发策略
    private Long ruleRelationId;//关联关系id
    private Long thresholdGroupId;  //阈值组ID
    private Long policyId; //分发策略ID

}
