package com.bocloud.mcs.collector.smis;

import org.apache.commons.lang3.StringUtils;

import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SmisCimModel extends HashMap<String, Object> {

    public SmisCimModel(String paramName) {
        this(paramName, "", "", null, null, null);
    }

    public SmisCimModel(String paramName, String paramPath) {
        this(paramName, paramPath, "", null, null, null);
    }

    public SmisCimModel(String paramName, String paramPath, String paramCondition) {
        this(paramName, paramPath, paramCondition, null, null, null);
    }

    public SmisCimModel(String paramName, String paramPath, List<String> paramConditions) {
        this(paramName, paramPath, paramConditions, null, null, null);
    }

    public SmisCimModel(String paramName, String paramPath, String paramCondition, String associatorName) {
        this(paramName, paramPath, paramCondition, associatorName, null, null);
    }

    public SmisCimModel(String paramName, String paramPath, List<String> paramConditions, String associatorName) {
        this(paramName, paramPath, paramConditions, associatorName, null, null);
    }

    public SmisCimModel(String paramName, String paramPath, String paramCondition, String associatorName, String associatorCondition) {
        this(paramName, paramPath, paramCondition, associatorName, associatorCondition, null);
    }

    public SmisCimModel(String paramName, String paramPath, List<String> paramConditions, String associatorName, List<String> associatorConditions) {
        this(paramName, paramPath, paramConditions, associatorName, associatorConditions, null);
    }

    public SmisCimModel(String paramName, String paramPath, String paramCondition, String associatorName, String associatorCondition, String associatorAssociator) {
        this(
                paramName,
                paramPath,
                StringUtils.isEmpty(paramCondition) ? null : Collections.singletonList(paramCondition),
                associatorName,
                StringUtils.isEmpty(associatorCondition) ? null : Collections.singletonList(associatorCondition),
                associatorAssociator
        );
    }

    public SmisCimModel(String paramName, String paramPath, List<String> paramConditions, String associatorName, List<String> associatorConditions, String associatorAssociator) {
        this.put("name", StringUtils.isEmpty(paramName) ? null : paramName);
        this.put("path", StringUtils.isEmpty(paramPath) ? null : paramPath);
        this.put("mof", 100);
        this.put("query_language", "WQL");
        this.put("conditions", paramConditions);

        if (StringUtils.isNotEmpty(associatorName)) {
            Map<String, Object> associator = new HashMap<>();
            associator.put("name", StringUtils.isEmpty(associatorName) ? null : associatorName);
            associator.put("conditions", associatorConditions);

            if (StringUtils.isNotEmpty(associatorAssociator)) {
                Map<String, Object> associatorAssociatorMap = new HashMap<>();
                associatorAssociatorMap.put("name", StringUtils.isEmpty(associatorAssociator) ? null : associatorAssociator);
                if(SmisClass.STATS.equals(associatorAssociator)) {
                    associatorAssociatorMap.put("assoc_name", SmisClass.ELEMENT_STATS);
                }
                associator.put("associator", associatorAssociatorMap);
            }
            this.put("associator", associator);
        }
    }

    public SmisCimModel() {}

}
