package com.bocloud.mcs.service.internal;

import com.bocloud.common.enums.BoCloudMethod;
import com.bocloud.common.enums.BoCloudService;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.BocloudToken;
import com.bocloud.service.core.CurrentService;
import com.bocloud.service.core.Service;
import com.bocloud.service.http.core.ServiceFactory;
import com.bocloud.service.http.model.RemoteService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@Component
public class CspCloudVendorService implements InitializingBean {

    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private CurrentService currentService;
    private static Service service = Service.create(BoCloudService.CMS);
    private Map<String, Object> headers = new HashMap<>(4);

    /**
     * 查询平台的运维账号信息（仅FusionCloud适用）
     *
     * @return
     */
    public BocloudResult detailVendorAuth(Long vendorId) {
        String url = "/v1/vendors/" + vendorId + "/authentications";
        RemoteService remoteService = serviceFactory.build(service, url, BoCloudMethod.GET, headers, null);
        return remoteService.invoke();
    }

    @Override
    public void afterPropertiesSet() {
        this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        this.headers.put("source", currentService.getService().getName());
    }
}
