package com.bocloud.mcs.service.internal;

import com.bocloud.common.enums.BoCloudMethod;
import com.bocloud.common.enums.BoCloudService;
import com.bocloud.common.model.*;
import com.bocloud.common.utils.MapTools;
import com.bocloud.ims.enums.CloudProvider;
import com.bocloud.service.core.CurrentService;
import com.bocloud.service.core.Service;
import com.bocloud.service.http.core.ServiceFactory;
import com.bocloud.service.http.model.RemoteService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class NmsCloudVendorService implements InitializingBean {

    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private CurrentService currentService;
    private static Service service = Service.create(BoCloudService.NMS);
    private Map<String, Object> headers = new HashMap<>(4);

    /**
     * 查询已开启告警的平台
     *
     * @return
     */
    public BocloudResult list(CloudProvider cloudProvider) {
        List<Param> paramList = new ArrayList<>();
        paramList.add(new Param(MapTools.simpleMap("vendorCategory","NETWORK"),Sign.EQ));
        paramList.add(new Param(MapTools.simpleMap("type",cloudProvider.name()),Sign.EQ));
        paramList.add(new Param(MapTools.simpleMap("is_alarm","1"),Sign.EQ));
        RemoteService remoteService = serviceFactory.build(service, "/v1/vendors", BoCloudMethod.GET, headers,
                new Pager(1, 12, paramList, null).toMap(false));
        return remoteService.invoke();
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        this.headers.put("source", currentService.getService().getName());
    }

}
